--- xinetd-2.3.7/xinetd/access.c.stream_wait	2002-10-02 10:18:51.000000000 +0200
+++ xinetd-2.3.7/xinetd/access.c	2002-10-02 10:21:46.000000000 +0200
@@ -232,13 +232,21 @@
             SC_ID(scp), conn_addrstr(cp));
          return(AC_LIBWRAP);
       }
-      request_init(&req, RQ_DAEMON, server, RQ_FILE, cp->co_descriptor, 0);
-      fromhost(&req);
-      if (!hosts_access(&req)) {
-         msg(deny_severity, func, 
-            "libwrap refused connection to %s from %s", 
-            SC_ID(scp), conn_addrstr(cp));
-         return(AC_LIBWRAP);
+      /* Don't do tcp-wrappers for stream+wait services, since there
+       * is no way to get the address of the remote end (the child does
+       * the accept), and the child will accept several clients anyway,
+       * so it better use tcp-wrappers itself
+       */
+      if ( !( (SVC_SOCKET_TYPE( sp ) == SOCK_STREAM) && SC_WAITS( scp ) ) ) 
+      {
+	 request_init(&req, RQ_DAEMON, server, RQ_FILE, cp->co_descriptor, 0);
+	 fromhost(&req);
+	 if (!hosts_access(&req)) {
+	   msg(deny_severity, func, 
+	       "libwrap refused connection to %s from %s", 
+	       SC_ID(scp), conn_addrstr(cp));
+	   return(AC_LIBWRAP);
+	 }
       }
 #endif
    } /* LIBWRAP code block */
